char IMM_Init[] = "\
set screenDepth [winfo screendepth .]\n\
case $screenDepth in {\n\
    1         {\n\
                set activeBgColor     black\n\
                set activeFgColor     white\n\
                set disabledFgColor   \"\"\n\
                set selectBgColor     black\n\
		set selectFgColor     white\n\
                set BgColor           black\n\
                set FgColor           white\n\
              }\n\
    default   {\n\
                set activeBgColor     black\n\
                set activeFgColor     \"light gray\"\n\
                set disabledFgColor   \"\"\n\
                set selectBgColor     \"light gray\"\n\
		set selectFgColor     black\n\
                set BgColor           \"light gray\"\n\
                set FgColor           black\n\
              }\n\
}\n\
 \n\
option add *activeBackground          $activeBgColor          startupFile\n\
option add *activeForeground          $activeFgColor          startupFile\n\
option add *CheckButton.selector      $FgColor                startupFile\n\
option add *background                $BgColor                startupFile\n\
option add *foreground                $FgColor                startupFile\n\
option add *selectBackground          $selectBgColor          startupFile\n\
option add *Scale.activeForeground    $activeBgColor          startupFile\n\
option add *Scale.sliderForeground    $BgColor                startupFile\n\
option add *Scrollbar.foreground      $BgColor                startupFile\n\
option add *Scrollbar.activeForeground  $activeBgColor        startupFile\n\
option add *Button.disabledForeground $disabledFgColor        startupFile\n\
";
char MCL[] = "\
set version \"Version 3.5a1\"\n\
set timedurat 60\n\
set lasttime 0\n\
set hundredths 0\n\
set opt_size -1\n\
set server() {}\n\
wm iconname . \"IMM\"\n\
set locktransmit 0\n\
rename exit exit.old\n\
wm protocol . WM_DELETE_WINDOW {exit 0}\n\
proc exit status {\n\
    shutdown\n\
    exit.old $status\n\
}\n\
frame .menu -relief raised -borderwidth 1\n\
button .ok -width 34 -text $version -command mkRadio\n\
frame .frame -borderwidth 5\n\
button .frame.l1 -width 15 -relief flat -text \"Transmission\" -command redraw\n\
canvas .frame.canvas  -width 200 -height 10 -bd 3 -highlightthickness 0\n\
.frame.canvas create line 15 5 15 5  -fill blue -width 8 -tags line\n\
frame .menu.top -borderwidth 15\n\
pack append .frame .frame.l1 {top} .frame.canvas {bottom}\n\
pack append . .menu {top fillx} .frame {expand frame w} .ok {bottom fillx}\n\
proc blink {} {\n\
	global timedurat lasttime hundredths\n\
	if {$timedurat <= 0} {\n\
	if { [string first \"next\" [.frame.l1 config -text] ] >= 0} {\n\
		  .frame.l1 config -text \"Transmission\"\n\
	}\n\
	  set lasttime 0\n\
	  return;\n\
	}\n\
	after 5000 blink\n\
	set currtime [timeofday]\n\
	if {$lasttime == 0} {\n\
		set lasttime $currtime\n\
	}\n\
	set timediff [expr $currtime-$lasttime]\n\
	if {$timediff < 5} return;\n\
	.frame.l1 config -text \"next image $timedurat\"\n\
	set timedurat [expr $timedurat-$timediff]\n\
	set lasttime $currtime\n\
}\n\
proc setWidth {w width} {\n\
    set x2 [expr $width * 2 + 15] \n\
    $w coords line 15 5 $x2 5\n\
}\n\
";
char RADIO[] = "\
set opt_dither 0\n\
set opt_smooth 0\n\
set opt_noreset 0\n\
set viewlock 1\n\
set transmitname \"Transmit\"\n\
set postProcFile \"PostProcessor\"\n\
proc mkPostProcess {{w .form}} {\n\
    global postProcFile\n\
    frame $w.postProc\n\
    entry $w.postProc.entry -relief sunken -width 40 -textvariable postProcFile\n\
    label $w.postProc.label -text \"Post Processor Executable\"\n\
    pack append $w.postProc \\\n\
        $w.postProc.entry right \\\n\
        $w.postProc.label left \n\
    focus $w.postProc.entry\n\
    pack append $w $w.postProc {bottom fillx}\n\
}        \n\
proc mkRadio {{w .r1}} {\n\
    global opt_size opt_normalize opt_smooth locktransmit version \\\n\
	transmitname viewlock postProcFile\n\
    catch {destroy $w}\n\
    toplevel $w\n\
    wm title $w \"$version - Options\"\n\
    wm iconname $w \"IMM Options\"\n\
    frame $w.frame -borderwidth 5\n\
    pack append $w.frame \\\n\
	[frame $w.frame.left -borderwidth 2 -relief sunken] {left expand padx 2m} \\\n\
	[frame $w.frame.right -borderwidth 2 -relief sunken] {left expand padx 2m} \\\n\
	[frame $w.frame.trans -borderwidth 2 -relief sunken] {right expand padx 2m}\n\
    pack append $w.frame.left \\\n\
	[radiobutton $w.frame.left.b1 -text \"Default Screen\" -variable opt_size \\\n\
	-relief flat -value -1 -anchor w] {fillx} \\\n\
	[radiobutton $w.frame.left.b2 -text \"Tiled Screen\" -variable opt_size \\\n\
	    -relief flat -value 0 -anchor w] {fillx} \\\n\
	[radiobutton $w.frame.left.b3 -text \"Full Screen\" -variable opt_size \\\n\
	    -relief flat -value 5 -anchor w] {fillx} \\\n\
	[radiobutton $w.frame.left.b5 -text \"Window\" -variable opt_size \\\n\
	    -relief flat -value 10 -anchor w] {fillx} \\\n\
	[radiobutton $w.frame.left.b4 -text \"Archive\" -variable opt_size \\\n\
	    -relief flat -value 11 -anchor w] {fillx} \\\n\
	[radiobutton $w.frame.left.b6 -text \"$postProcFile\" -variable opt_size \\\n\
	    -relief flat -value 12 -anchor w -command \"mkPostProcess $w\"] {fillx}\n\
    pack append $w.frame.right \\\n\
     [checkbutton $w.frame.right.b1 -text \"Dither\" -variable opt_dither \\\n\
          -relief flat -anchor w] {fillx} \\\n\
      [checkbutton $w.frame.right.b2 -text \"Smooth\" -variable opt_smooth \\\n\
          -relief flat -anchor w] {fillx} \\\n\
      [checkbutton $w.frame.right.b3 -text \"Debug\" -command  \"debug_proc\" \\\n\
          -relief flat -anchor w] {fillx} \\\n\
      [checkbutton $w.frame.right.b4 -text \"Noreset\" -variable opt_noreset \\\n\
          -relief flat -anchor w] {fillx}\n\
    pack append $w.frame.trans \\\n\
      [button $w.frame.trans.send -text $transmitname -command \"mkListbox2 $w\"] \\\n\
          {fill} \\\n\
      [button $w.frame.trans.info -text Viewers -command \"mkViewbox2 $w\"] \\\n\
          {top expand fill} \\\n\
      [button $w.frame.trans.log -text Log -command \"mkLogbox2 $w\"] \\\n\
          {top expand fill} \\\n\
      [button $w.frame.trans.host -text MyName -command \"mkHostname $w\"] \\\n\
          {top expand fill} \\\n\
      [button $w.frame.trans.clear -text Default -command \"exec xv -root -clear &\"] \\\n\
          {bottom expand fill}\n\
    if { [info exists viewlock] == 0} {\n\
        $w.frame.trans.info configure -state disabled}\n\
    frame $w.frame2	\n\
    pack append $w.frame2 \\\n\
      [button $w.frame2.ok -text OK -command \"destroy $w\"] \\\n\
          {left expand fill}\n\
     pack append $w $w.frame {top expand fill} \\\n\
          $w.frame2 {bottom fill} \n\
}\n\
";
char LISTBOX[] = "\
set opt_list_repeat 1\n\
proc initserver { w index rate} {\n\
	global transmitname locktransmit opt_list_repeat\n\
 	 immserv $index $opt_list_repeat $rate\n\
	set transmitname $index\n\
	set locktransmit 1\n\
}\n\
proc writefile {listbox} {  	\n\
    set fio [open \"~/.imm.def\" w]	\n\
    for {set boxsize 0} {$boxsize < [$listbox size]} {incr boxsize} {\n\
	set line [$listbox get $boxsize]\n\
	if { [llength $line] == 0} continue\n\
	if {[file isdirectory $line] == 0} continue\n\
	puts $fio $line\n\
    }	\n\
    close $fio\n\
}\n\
proc mkDialog {w msgArgs args} {\n\
    catch {destroy $w}\n\
    toplevel $w -class Dialog\n\
    set oldFocus [focus]\n\
 \n\
    frame $w.top -relief raised -border 1\n\
    frame $w.bot -relief raised -border 1\n\
    pack append $w $w.top {top fill expand} $w.bot {top fill expand}\n\
    \n\
    eval message $w.top.msg -justify center \\\n\
          -font -Adobe-times-medium-r-normal--*-180* $msgArgs\n\
    pack append $w.top $w.top.msg {top expand padx 5 pady 5}\n\
    \n\
 \n\
    if {[llength $args] > 0} {\n\
      set arg [lindex $args 0]\n\
      frame $w.bot.0 -relief sunken -border 1\n\
      pack append $w.bot $w.bot.0 {left expand padx 20 pady 20}\n\
      button $w.bot.0.button -text [lindex $arg 0] \\\n\
              -command \"[lindex $arg 1]; catch {destroy $w}; focus $oldFocus\"\n\
      pack append $w.bot.0 $w.bot.0.button {expand padx 12 pady 12}\n\
      bind $w <1> \"$w.bot.0.button config -relief sunken\"\n\
      bind $w <ButtonRelease-1> \\\n\
              \"catch {destroy $w}; focus $oldFocus\"\n\
bind $w <Return> \"[lindex $arg 1]; catch {destroy $w}; focus $oldFocus\"\n\
      focus $w\n\
 \n\
      set i 1\n\
      foreach arg [lrange $args 1 end] {\n\
          button $w.bot.$i -text [lindex $arg 0] \\\n\
                  -command \"[lindex $arg 1];focus $oldFocus\"\n\
	  #                  -command \"[lindex $arg 1]; catch {destroy $w}; focus $oldFocus\"\n\
          pack append $w.bot $w.bot.$i {left expand padx 20}\n\
          set i [expr $i+1]\n\
      }\n\
    }\n\
}\n\
proc mkForm {{w .form}} {\n\
    frame $w.directory\n\
    entry $w.directory.entry -relief sunken -width 40\n\
    bind $w.directory.entry <Return> \"$w.enter invoke\"\n\
    label $w.directory.label -text \"Directory\"\n\
    pack append $w.directory \\\n\
	$w.directory.entry right \\\n\
	$w.directory.label left 	\n\
    focus $w.directory.entry	\n\
    button $w.enter -text \"Enter entry into table\" \\\n\
	-command \"$w.frame.list insert 0 \\[$w.directory.entry get\\]; \\\n\
		writefile $w.frame.list; \\\n\
		destroy $w.directory; \\\n\
		destroy $w.enter\"\n\
    pack append $w $w.directory {bottom fillx} \\\n\
	$w.enter {bottom fill}\n\
}	 	\n\
proc mkListbox2 {{w .l2}} {\n\
    global opt_list_repeat	 \n\
    catch {destroy $w}\n\
    toplevel $w\n\
    wm title $w \"Transmit\"\n\
    wm iconname $w \"Transmit\"\n\
    wm minsize $w 1 1\n\
    frame $w.frame -borderwidth 10\n\
    scrollbar $w.frame.scroll -relief sunken -command \"$w.frame.list yview\"\n\
    listbox $w.frame.list -yscroll \"$w.frame.scroll set\" -relief sunken \\\n\
	    -setgrid 1 -width 50\n\
    pack append $w.frame $w.frame.scroll {right filly} \\\n\
	    $w.frame.list {left expand fill}\n\
    if {[file readable \"~/.imm.def\"] == 1 } {\n\
	set fio [open \"~/.imm.def\" r]\n\
	while { [gets $fio line] != -1} {\n\
		$w.frame.list insert 0 $line\n\
	}\n\
	close $fio\n\
    }	\n\
    bind $w.frame.list <Double-1> \\\n\
	\"mkServer $w \\[lindex \\[selection get\\] 0\\]\"\n\
    frame $w.butframe -borderwidth 10\n\
    button $w.butframe.quit -text dismiss -command \"destroy $w\"\n\
    button $w.butframe.start -text start -command \\\n\
	\"mkServer $w \\[lindex \\[selection get\\] 0\\]\"\n\
    button $w.butframe.create -text create -command \"mkForm $w\"\n\
    button $w.butframe.delete -text delete -command \\\n\
	\"$w.frame.list delete \\[$w.frame.list curselection\\]; \\\n\
	writefile $w.frame.list\"\n\
    pack append $w.butframe $w.butframe.quit {left padx 4 } \\\n\
	$w.butframe.start {left padx 4} \\\n\
	$w.butframe.create {left padx 4} \\\n\
	$w.butframe.delete {left padx 4}\n\
    pack append $w $w.frame {top expand filly frame center} \\\n\
	$w.butframe {bottom fillx}\n\
}\n\
";
char VIEWBOX[] = "\
proc memberadd {goodnum badnum retriesnum packnum user member} {\n\
	global username good bad retries packrecv viewlock\n\
	if {[info exists good($member)] == 0} {\n\
		set username($member) $user\n\
		set good($member) $goodnum\n\
		set bad($member) $badnum\n\
		set retries($member) $retriesnum\n\
		set packrecv($member) $packnum\n\
		set viewlock 1\n\
	} else {\n\
		set username($member) $user\n\
		incr good($member) $goodnum\n\
		incr bad($member) $badnum\n\
		incr retries($member) $retriesnum\n\
		incr packrecv($member) $packnum\n\
		set viewlock 1\n\
	}\n\
}\n\
proc serveradd {member servername namefile} {\n\
	global server good bad retries packrecv filelog username\n\
	if {[info exists good($member)] == 0} {\n\
		set good($member) 0\n\
		set bad($member) 0\n\
		set retries($member) 0\n\
		set packrecv($member) 0\n\
		set username($member) $servername\n\
	}	\n\
	if {[info exists server($member)] == 0} {\n\
		set server($member) 1\n\
	} else {\n\
		incr server($member)\n\
	}\n\
	if {[llength $filelog] > 48} {\n\
		lreplace $filelog 0 0\n\
	}\n\
	lappend filelog \"$namefile $servername\"\n\
	catch {.r1.log.list insert 0 \"$namefile $servername\"}\n\
}\n\
proc memberreset {w} {\n\
    global username good bad retries packrecv viewlock server	\n\
	foreach user [array names good] {\n\
		unset username($user)\n\
		unset good($user)\n\
		unset bad($user)\n\
		unset retries($user)\n\
		unset packrecv($user)\n\
	}\n\
	foreach user [array names server] {\n\
		unset server($user)\n\
	}\n\
	set server() {}\n\
	unset viewlock\n\
	destroy $w\n\
}\n\
proc loginfo {w} {\n\
	global good server\n\
	set viewers [array size good]\n\
      mkDialog .info \"-text {Authored by Winston Dang} -aspect 400\" \\\n\
               \"OK {}\"\n\
}                     \n\
proc mkViewbox2 {{w .v2}} {\n\
    global username good bad retries packrecv viewlock server\n\
    catch {destroy $w}\n\
    toplevel $w\n\
    wm title $w \"Viewer Stats\"\n\
    wm iconname $w \"Viewers\"\n\
    wm minsize $w 1 1\n\
    frame $w.viewer -borderwidth 10\n\
    label $w.viewer.label -anchor w -text [format\\\n\
	\"Good Bad   Pack     Retr %20.20s %d %30.30s %d\" \\\n\
 	\"users\" [array size good] \"servers\" [ expr [array size server] -1]]\n\
    pack append $w.viewer $w.viewer.label {left top expand fillx} \n\
 		\n\
    scrollbar $w.viewer.scroll -relief sunken -command \"$w.viewer.list yview\"\n\
    listbox $w.viewer.list -yscroll \"$w.viewer.scroll set\" -relief sunken \\\n\
	    -setgrid 1\n\
    pack append $w.viewer $w.viewer.scroll {right filly} \\\n\
	    $w.viewer.list {left expand fill}\n\
    if {[info exists viewlock] == 1} {	\n\
	foreach user [array names good] {\n\
		if {[info exists server($user)] == 0} {	\n\
			$w.viewer.list insert 0 \\\n\
			[format \"%4.4d %3.3d %8.8d %4.4d %s\" \\\n\
			$good($user) $bad($user) \\\n\
			$packrecv($user) $retries($user) $username($user)]\n\
		} else {\n\
			$w.viewer.list insert 0 \\\n\
			[format \"%4.4d %3.3d %8.8d %4.4d %-40.40s ** %4.4d\"\\\n\
			$good($user) $bad($user) \\\n\
			$packrecv($user) \\\n\
			$retries($user) $username($user) $server($user)]\n\
		}			\n\
	}\n\
    }\n\
    frame $w.butframe -borderwidth 10\n\
    button $w.butframe.quit -text OK -command \"destroy $w\"\n\
    pack append $w.butframe $w.butframe.quit {left expand fillx} \\\n\
	[button $w.butframe.info -command \"loginfo $w\"] \\\n\
	 {left} \\\n\
	[button $w.butframe.clear -text \"clear table\" \\\n\
	-command \"memberreset $w\"] {left expand fillx}  \n\
    pack append $w $w.viewer {top expand filly frame center} \\\n\
	$w.butframe {bottom fillx}\n\
}\n\
";
char FILEBOX[] = "\
set filelog {}\n\
proc showfile {w namefile} {\n\
	global immdirectory\n\
	set xvfile \"$immdirectory/[lindex $namefile 0]\"\n\
	if {[file exists $xvfile] == 1} {\n\
		mkDialog .callup \"-text {view $xvfile} -aspect 400\" \\\n\
	              \"View {exec xv $xvfile &}\" \"Cancel {}\"\n\
	} else {\n\
		mkDialog .warn \"-text {$xvfile is not available} -aspect 400\" \\\n\
	              \"OK {}\"\n\
	}\n\
}\n\
proc mkLogbox2 {{w .log2}} {\n\
    global filelog\n\
    catch {destroy $w}\n\
    toplevel $w\n\
    wm title $w \"Log File\"\n\
    wm iconname $w \"IMM Log\"\n\
    wm minsize $w 1 1\n\
    frame $w.log -borderwidth 10\n\
    scrollbar $w.log.scroll -relief sunken -command \"$w.log.list yview\"\n\
    listbox $w.log.list -yscroll \"$w.log.scroll set\" -relief sunken \\\n\
	    -setgrid 1\n\
   pack append $w.log $w.log.scroll {right filly} \\\n\
	    $w.log.list {left expand fill}\n\
    foreach user $filelog {\n\
	$w.log.list insert 0 $user\n\
    }\n\
    frame $w.butframe -borderwidth 10\n\
    button $w.butframe.quit -text OK -command \"destroy $w\"\n\
    pack append $w.butframe $w.butframe.quit {left expand fillx}\n\
    pack append $w $w.log {top expand filly frame center} \\\n\
	$w.butframe {bottom fillx}\n\
    bind $w.log.list <Double-1> \\\n\
	\"showfile $w \\[lindex \\[selection get\\] 0\\]\"\n\
}\n\
";
char HOSTBOX[] = "\
proc reset_host {w name} {\n\
	global hostname\n\
	set hostname $name\n\
	chgvarhost $name\n\
	destroy $w\n\
}\n\
proc mkHostname {{w .form}} {\n\
    global hostname\n\
    catch {destroy $w}\n\
    toplevel $w\n\
    wm title $w \"MyName\"\n\
    wm iconname $w \"Form\"\n\
    message $w.msg -font -Adobe-times-medium-r-normal--*-180* -width 4i \\\n\
	    -text \"Enter the name by which you want to be known to the world.  Click the \\\"OK\\\" button or type return when you're done.\"\n\
    foreach i {f1} {\n\
	frame $w.$i -bd 1m\n\
	entry $w.$i.entry -relief sunken -width 40\n\
	bind $w.$i.entry <Return> \"reset_host $w \\[$w.$i.entry get\\]\"\n\
	label $w.$i.label\n\
	pack $w.$i.entry -side right\n\
	pack $w.$i.label -side left\n\
    }\n\
    $w.f1.label config -text MyName:\n\
    $w.f1.entry insert 0 $hostname\n\
    button $w.ok -text OK -command \"reset_host $w \\[$w.f1.entry get\\]\"\n\
    pack $w.msg $w.f1 $w.ok -side top -fill x\n\
    focus $w.f1.entry	\n\
}\n\
";
char SERVERBOX[] = "\
set REPEAT 1\n\
set DEBUG 0\n\
set KRATE 25\n\
set DELAY 60\n\
set CURRENT 0\n\
set MDU 1400\n\
proc mkServer {w name} {\n\
    global transmitname\n\
    set transmitname $name\n\
    catch {destroy $w}\n\
    set w .server\n\
    toplevel $w\n\
    wm title $w \"Image Multicast Server Tool\"\n\
    wm iconname $w \"IMMSERVER\"\n\
    # positionWindow $w\n\
    frame $w.menu -relief raised -bd 2\n\
    pack $w.menu -side top -fill x\n\
    set m $w.menu.options.m\n\
    menubutton $w.menu.options -text \"Options\" -menu $m -underline 0\n\
    menu $m\n\
    $m add checkbutton -label \"Send only updated files\" -variable CURRENT\n\
    $m add checkbutton -label \"Continuous Repeat\" -variable REPEAT\n\
    $m add separator\n\
    $m add command -label \"Set MDU Size\" -command setMDU\n\
    set m $w.menu.cascade.m\n\
    menubutton $w.menu.cascade -text \"Debug\" -menu $m -underline 0\n\
    menu $m\n\
    $m add cascade -label \"Debug\" \\\n\
	    -menu $w.menu.cascade.m.check -underline 0\n\
    set m $w.menu.cascade.m.check\n\
    menu $m\n\
    $m add radio -label \"OFF\" -variable DEBUG -value 0\n\
    $m add radio -label \"Low Level\" -variable DEBUG -value 2\n\
    $m add radio -label \"High Level\" -variable DEBUG -value 9\n\
    $m invoke 1\n\
    \n\
    \n\
    pack $w.menu.options -side left\n\
    pack $w.menu.cascade -side right\n\
    # Make entries\n\
    #vertically pack labels\n\
    entry $w.entry3 -relief sunken -width 30 -textvariable transmitname \n\
    #vertically pack entry boxes\n\
    pack  $w.entry3\n\
    # make scale for rate entry\n\
    scale $w.scale1 -width 10 -orient horizontal -variable KRATE \\\n\
	    -length 300 -from 0 -to 125 -tickinterval 25\n\
    scale $w.scale2 -width 10 -orient horizontal -variable DELAY \\\n\
	    -length 300 -from 0 -to 60 -tickinterval 10\n\
    label $w.label4 -width 20 -padx 20 -text \"Transfer Rate (kbps)\"\n\
    label $w.label5 -width 20 -padx 20 -text \"Timer Delay Interval (min)\"\n\
    pack $w.scale1 $w.label4 $w.scale2 $w.label5\n\
    #horizontally pack columns\n\
    button $w.transmit -background green -text \"Transmit\" -command {startserver}\n\
    button $w.dismiss -background purple -text Dismiss -command {quitserver}\n\
    pack $w.transmit $w.dismiss -side left -expand 1\n\
}\n\
proc startserver {} {\n\
    #external variables have to be declared as \"global\"\n\
    global KRATE DEBUG transmitname REPEAT DELAY CURRENT MDU\n\
    set holdtime [expr $DELAY * 60]\n\
    set brate [expr $KRATE * 1000]\n\
    set rep [expr $REPEAT == 0]\n\
    immserv -a -d $DEBUG -r $rep -s $brate -m $MDU -l $holdtime -o $CURRENT $transmitname\n\
    destroy .server\n\
}\n\
proc quitserver {} {\n\
    global transmitname\n\
    set transmitname Transmit\n\
    destroy .server\n\
}\n\
proc setMDU {{w .r1}} {\n\
    global MDU\n\
    catch {destroy $w}\n\
    toplevel $w\n\
    wm title $w \"Set MDU\"\n\
    wm iconname $w \"Set \"\n\
    wm minsize $w 1 1\n\
    frame $w.frame -borderwidth 10\n\
    label $w.frame.label -text \"Enter MDU size:\"\n\
    entry $w.frame.ent -width 10 -textvariable MDU\n\
    button $w.frame.quit -text dismiss -command \"destroy $w\"\n\
    pack $w.frame $w.frame.label $w.frame.ent -side left\n\
    pack $w.frame.quit -side bottom \n\
}\n\
";
