# IMM log listbox  
# By Winston Dang  wkd@hawaii.edu
# Jan 28 1994

# Arguments:
#    w -	Name to use for new top-level window.
set filelog {}
proc showfile {w namefile} {
	global immdirectory
	set xvfile "$immdirectory/[lindex $namefile 0]"
	if {[file exists $xvfile] == 1} {
		mkDialog .callup "-text {view $xvfile} -aspect 400" \
	              "View {exec xv $xvfile &}" "Cancel {}"
	} else {
		mkDialog .warn "-text {$xvfile is not available} -aspect 400" \
	              "OK {}"
	}
}
proc mkLogbox2 {{w .log2}} {
    global filelog
    catch {destroy $w}
    toplevel $w
    wm title $w "Log File"
    wm iconname $w "IMM Log"
    wm minsize $w 1 1
    frame $w.log -borderwidth 10
    scrollbar $w.log.scroll -relief sunken -command "$w.log.list yview"
    listbox $w.log.list -yscroll "$w.log.scroll set" -relief sunken \
	    -setgrid 1
   pack append $w.log $w.log.scroll {right filly} \
	    $w.log.list {left expand fill}
    foreach user $filelog {
	$w.log.list insert 0 $user
    }
    frame $w.butframe -borderwidth 10
    button $w.butframe.quit -text OK -command "destroy $w"
    pack append $w.butframe $w.butframe.quit {left expand fillx}
    pack append $w $w.log {top expand filly frame center} \
	$w.butframe {bottom fillx}
    bind $w.log.list <Double-1> \
	"showfile $w \[lindex \[selection get\] 0\]"
}





