# IMM main window display
set version "Version 3.5a1"
set timedurat 60
set lasttime 0
set hundredths 0
set opt_size -1
set server() {}
wm iconname . "IMM"
set locktransmit 0
rename exit exit.old
wm protocol . WM_DELETE_WINDOW {exit 0}

# redefine the exit procedure
proc exit status {
    shutdown
    exit.old $status
}


# Create the main window
frame .menu -relief raised -borderwidth 1
button .ok -width 34 -text $version -command mkRadio
frame .frame -borderwidth 5
button .frame.l1 -width 15 -relief flat -text "Transmission" -command redraw
canvas .frame.canvas  -width 200 -height 10 -bd 3 -highlightthickness 0
.frame.canvas create line 15 5 15 5  -fill blue -width 8 -tags line

frame .menu.top -borderwidth 15

pack append .frame .frame.l1 {top} .frame.canvas {bottom}
pack append . .menu {top fillx} .frame {expand frame w} .ok {bottom fillx}

# timer setup
proc blink {} {
	global timedurat lasttime hundredths
	if {$timedurat <= 0} {
	if { [string first "next" [.frame.l1 config -text] ] >= 0} {
		  .frame.l1 config -text "Transmission"
	}
	  set lasttime 0
	  return;
	}
	after 5000 blink
	set currtime [timeofday]
	if {$lasttime == 0} {
		set lasttime $currtime
	}
	set timediff [expr $currtime-$lasttime]
	if {$timediff < 5} return;
	.frame.l1 config -text "next image $timedurat"
	set timedurat [expr $timedurat-$timediff]
	set lasttime $currtime
}

proc setWidth {w width} {
    set x2 [expr $width * 2 + 15] 
    $w coords line 15 5 $x2 5
#    $w coords line 20 15 20 35 $x2 35 $x2 45 $width 25 $x2 5 $x2 15 20 15
}


